/**
 * IPaymentRepository 接口
 */
import type {
  CreatePaymentOrderResponse,
  PayChannel,
  PaymentOrderStatusResponse,
  PaymentPlansResponse,
} from "@/data/dto/payment";
import type { Result } from "@/utils/result";

export interface IPaymentRepository {
  /** 获取套餐列表。 */
  getPlans(): Promise<Result<PaymentPlansResponse>>;

  /** 获取本地缓存套餐列表。 */
  getCachedPlans(): Promise<Result<PaymentPlansResponse | null>>;

  /** 获取咖啡打赏套餐列表。 */
  getTipPlans(): Promise<Result<PaymentPlansResponse>>;

  /** 清除本地缓存套餐列表。 */
  clearCachedPlans(): Promise<Result<void>>;

  /** 创建支付订单。 */
  createOrder(
    planId: string,
    payChannel: PayChannel,
    autoRenew: boolean,
  ): Promise<Result<CreatePaymentOrderResponse>>;

  /** 查询支付订单状态。 */
  getOrderStatus(orderId: string): Promise<Result<PaymentOrderStatusResponse>>;
}
